import Flutter
import UIKit
import TeachmintSdk
import SwiftUI

public class SwiftFlutterTeachstackSdkPlugin: NSObject, FlutterPlugin,TeachmintRoomViewDelegate{
    var window:UIWindow?
    var myView:UIView?
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "flutter_teachstack_sdk", binaryMessenger: registrar.messenger())
        let instance = SwiftFlutterTeachstackSdkPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        if(call.method.elementsEqual("liveClass")) {
            let arguments = call.arguments as? NSDictionary
            guard let url = arguments?["url"] as? String else {return}
            let yourAppGroupName = arguments?["yourAppGroupName"] as? String
            window = UIApplication.shared.windows.filter {$0.isKeyWindow}.first
            let view =  TMEvaasBuilder(delegate: self,
                                       suiteName: yourAppGroupName,
                                       url: url,
                                       language: "en",
                                       host: "api.teachmint.com")
            let c = UIHostingController(rootView: view)
            c.view.frame = UIScreen.main.bounds
            window?.addSubview(c.view)
            myView = c.view
            window?.makeKeyAndVisible()
            
        }
    }
}

extension SwiftFlutterTeachstackSdkPlugin{
    public func onMeetingEnded(reason: String, recording: Bool, study_material: Bool, session_id: String?) {
        myView?.removeFromSuperview()
    }
    
    public func trackEvent(eventName: String, eventData: [String : String]) {
        
    }
    
}
